<?php

/**
 * notificacion_titulo actions.
 *
 * @package    canon
 * @subpackage notificacion_titulo
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class notificacion_tituloActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CA_NOTIFICACION_TITULO',
        'RMN_TITULO',
        'CA_TIPO_OPERACION'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'RMN_TITULO' =>
        array(
            'id_titulo' => 'CA_NOTIFICACION_TITULO'
        ),
        'CA_TIPO_OPERACION' =>
        array(
            'id_tipo_operacion' => 'CA_NOTIFICACION_TITULO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CA_NOTIFICACION_TITULO' =>
        array(
            'id_notificacion_titulo' => 'id_notificacion_titulo',
            'id_titulo' => 'id_titulo',
            'id_tipo_operacion' => 'id_tipo_operacion',
            'fecha_proceso' => 'fecha_proceso',
            'observacion' => 'observacion',
            'correo' => 'correo',
            'num_ticket' => 'num_ticket'
        ),
        'RMN_TITULO' =>
        array(
            'cod_titulo' => 'cod_titulo'
        ),
        'CA_TIPO_OPERACION' =>
        array(
            'descripcion' => 'descripcion',
            'desc_corta' => 'desc_corta',
            'estado' => 'estado_tipope'
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CA_NOTIFICACION_TITULO' => array(
            'id_notificacion_titulo,a' => array('!=' => array(-1)),
            'id_notificacion_titulo,b' => array('=' => array('id_notificacion_titulo')),
            'id_titulo' => array('=' => array('id_titulo')),
            'num_ticket' => array('=' => array('num_ticket')),
            'id_tipo_operacion' => array('=' => array('id_tipo_operacion')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
        'RMN_TITULO' =>
        array(
            'cod_titulo' => array('LIKEALLPLUS' => array('input', '%'))
        )
    ); // filtros de condicion or
    protected $fields_orderBy = array(
        'id_notificacion_titulo'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;



    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_notificacion_titulo'; //identificador de la tabla
    protected $id_names = array('id_notificacion_titulo'); //llave primaria
    protected $field_names = array('id_titulo', 'id_tipo_operacion', 'fecha_proceso', 'observacion', 'correo', 'num_ticket'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CA_NOTIFICACION_TITULO'; //tabla en la cual se aplican los cambios
    protected $has_activo = false; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_notificacion_titulo'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        //$logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            //Notificar por correo 
            $cod_titulo = $this->list_data[0]['cod_titulo'];
            $subject = "Notificacion de Canon titulo: $cod_titulo";
            $recipients = array(
                array(
                        'email' => sfConfig::get('app_email_envio'),
                        'name' => 'Canon Superficiario'
                     )
            );
//            $ccRecipients = array(
//                array(
//                        'email' => 'harold.murcia@sofhouse.net',
//                        'name' => 'Test Name'
//                     )
//            );
            
            //cuerpo del mensaje
            $fecha_creacion = CN_TABLE::fechaSistema();
            $num_ticket = $this->list_data[0]['num_ticket'];
            $mensaje_estado = $this->list_data[0]['mensaje_estado'];
            $correo = $this->list_data[0]['correo'];
            $body = <<<EOD
                <html><body> 
                <br/>
                Bogotá, $fecha_creacion
                <br/>
                <br/><br/>
                Por medio de la presente se enviá correo de la notificación al título, según detalles a continuación:</b><br/><br/>
                <b>No. Ticket: </b>$num_ticket<br/>      
                <b>Tipo Operación: </b>$mensaje_estado<br/>      
                <b>Codigo del Título: </b>$cod_titulo<br/>      
                <b>Correo de Origen: </b>$correo<br/>        
                <br></br>
                </body></html>
EOD;

            CN_TABLE::sendMail($recipients, array(), $subject, $body, array());
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Agrega una fila a la tabla
     *
     * @param sfWebRequest $request
     */
    public function executeAdd(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
            if ($value == 'null') {
                unset($request[$key]);
            }
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /**
         * VALIDAR ERRORES DE PROCEDIMIENTO
         */
        try {

            // Validar operación
            $errors = $this->validateAdd($request);

            /*
             * Validar errors
             */
            if ($errors == null) {

                /**
                 * return sfWebRequest Changed Request with additional parameters.
                 */
                $request = $this->preprocessRequest("ADD", $request);


                // Ejecutar la operación normalmente        
                $this->add($request);

                /**
                 * idEstado: Identificador estado generado.
                 * mensajeEstado
                 */
                $id_notificacion_titulo = $this->list_data[0]['id_notificacion_titulo'];

                $sql = <<<EOD
select
nottit.id_notificacion_titulo as id_Estado,
tipope.descripcion as mensaje_Estado,
tit.cod_titulo,
                        
nottit.id_notificacion_titulo,
tipope.descripcion,
nottit.id_titulo,
nottit.id_tipo_operacion,
nottit.fecha_proceso,
nottit.observacion,
nottit.correo,
nottit.num_ticket                        
from ca_notificacion_titulo nottit
left join ca_tipo_operacion tipope
on tipope.id_tipo_operacion = nottit.id_tipo_operacion
left join rmn_titulo tit
on tit.id_titulo = nottit.id_titulo
where
nottit.id_notificacion_titulo = $id_notificacion_titulo 
EOD;

                $this->list_data = CN_TABLE::executeSQL($sql);

                /**
                 * Acciones posteriores a la original
                 * 
                 * return sfWebRequest Changed Request with additional parameters.
                 */
                $this->postprocessRequest("ADD", $request, $this->list_data);
            } else {

                /*
                 * Validar que errors es un array con datos
                 */
                if (is_array($errors)) {
                    $errors['operacion'] = "ADD";
                    $this->list_errors = $errors;
                }

                // Devolver los errores vía Json
                if (isset($errors['mensaje'])) {
                    $mensaje = "[ADD sfAPIActions] " . $errors['mensaje'];
                } else {
                    $mensaje = "[ADD sfAPIActions] ERROR !!!";
                }


                $this->logMessage($mensaje);
                $this->logMessage("status -1");

                $this->status = $this->STATUS_FAILURE;
                $this->mensajeError = $mensaje;
                $this->list_data = array();
            }
        } catch (Doctrine_Connection_Exception $e) {

            $mensaje = "[ADD sfAPIActions] ERROR Doctrine_Connection_Exception !!!";


            $this->list_errors = array(
                'Code' => $e->getCode(),
                'Message' => $e->getMessage(),
                'Line' => $e->getLine(),
                'Trace' => $e->getTraceAsString(),
                'mensaje' => $mensaje,
                'mensaje' => $mensaje,
                'operacion' => "ADD"
            );

            $this->logMessage($mensaje);
            $this->logMessage("status -1");
            $this->logMessage("Code " . $e->getCode());
            $this->logMessage("Message " . $e->getMessage());

            $this->status = $this->STATUS_FAILURE;
            $this->mensajeError = $mensaje;
            $this->list_data = array();
        } catch (Exception $e) {

            $mensaje = "[ADD sfAPIActions] ERROR Exception !!!";


            $this->list_errors = array(
                'Code' => $e->getCode(),
                'Message' => $e->getMessage(),
                'Line' => $e->getLine(),
                'Trace' => $e->getTraceAsString(),
                'mensaje' => $mensaje,
                'operacion' => "ADD"
            );

            $this->logMessage($mensaje);
            $this->logMessage("status -1");
            $this->logMessage("Code " . $e->getCode());
            $this->logMessage("Message " . $e->getMessage());

            $this->status = $this->STATUS_FAILURE;
            $this->mensajeError = $mensaje;
            $this->list_data = array();
        }
    }

}
